<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",1);
//error_reporting(E_ALL);

if (version_compare(PHP_VERSION, '5.3.1', '<'))
{
	die('Your host needs to use PHP 5.3.1 or higher to run this version of Joomla!');
}
define('_JEXEC', 1);
defined( '_JEXEC' ) or die( 'Restricted access' );
define('DS', DIRECTORY_SEPARATOR);
$dirname=str_ireplace(DS.'modules'.DS.'mod_paymybill'.DS.'return','', dirname(__FILE__));

if (file_exists($dirname.DS.'defines.php'))
{
	include_once $dirname.DS.'defines.php';
}
if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', $dirname);
	require_once JPATH_BASE.DS.'includes/defines.php';
}
require_once JPATH_BASE.DS.'includes/framework.php';
// Mark afterLoad in the profiler.
JDEBUG ? $_PROFILER->mark('afterLoad') : null;
// Instantiate the application.
$app = JFactory::getApplication('site');

$lang = JFactory::getLanguage();
$extension = 'mod_paymybill';
$language_tag = $lang->getTag();
$reload = true;
$lang->load($extension, $dirname, $language_tag, $reload);

require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."helper.php");
$PMBHelper = new PMBHelper();

$session_id=isset($_GET['order_ref'])?$_GET['order_ref']:"";

if($session_id=="")
  exit;
$module_id=0;
$tarr=explode("-",$session_id);
$module_id=$tarr[1]+0;
if($module_id==0)
  exit;

$params=$PMBHelper->getWorkingModParams($module_id);

$method_name='PayuHungary';

require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
$pmbf=new PMBFunctions();
$details=$pmbf->getOrderDetails($session_id);

$order_paid=0;
$params=$PMBHelper->getWorkingModParams($module_id);
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
$pmbf=new PMBFunctions();
$details=$pmbf->getOrderDetails($session_id);
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."methods".DS."payuhungary.php");

$config = array(
	'MERCHANT' => $params['payuhungary_user'],																		//merchant account ID
	'SECRET_KEY' => $params['payuhungary_password'],																		//secret key for account ID	
	'METHOD' => "",																			//payment method	 empty -> select payment method on PayU payment page OR [ CCVISAMC, WIRE, CASH, PAYU_MOBILE ]
	'ORDER_DATE' => date("Y-m-d H:i:s"),													//date of transaction
	'LOGGER' => false,																		//transaction log
	'LOG_PATH' => 'log',																	//path of log file
	'ORDER_TIMEOUT' => 900,
	'LANGUAGE' => $params['payuhungary_language']
);

if ($params['payuhungary_language']=='HU') {
	define("LANGUAGE", "HU");
	define("LIVEUPDATE_TEST_TRANSACTION", "LiveUpdate teszt tranzakcio");
	define("BACKREF_REDIRECT_PAGE", "BackRef visszatero oldal");
	define("TIMEOUT_PAGE", "Idotullepes");
	define("SET_UP_MERCHANT", "Az sdk/config.php fajlban allitsa be a kereskedoi azonositojat (MERCHANT)");
	define("SET_UP_SECRET_KEY", "Az sdk/config.php fajlban allitsa be a titkos kulcsat (SECRET_KEY)");	
	define("METHOD_CCVISAMC", "Bankkartya");
	define("METHOD_PAYU_MOBILE", "PayU mobile");
	define("METHOD_WIRE", "atutalas");
	define("METHOD_CASH", "Utanvetel");
	define("METHOD_ON_PAYMENT_PAGE", "Fizeto oldali kivalasztas");
	define("PAYMENT_METHOD", "Fizetesi mod");
	define("SETTINGS", "Beallitas");
	define("PAYMENT_BUTTON", "PayU online fizetes inditasa");
	define("SELECT_ON_PAYMENT_PAGE", "a PayU fizetooldalon lehet kivalasztani");
	define("CARDS_FOR_TEST", "Teszt kartyak");		
	define("SUCCESFUL_PAYMENT", "Sikeres fizetes");
	define("UNSUCCESFUL_PAYMENT", "Sikertelen fizetes");
	define("CARD_NUMBER", "Kartya szam");
	define("EXPIRATION", "Lejarat");
	define("ANY_THREE_NUMBERS", "tetszoleges harom szam");
	define("ANY_LATER", "tetszoleges kesobbi datum");
	define("SUCCESSFUL_CARD_AUTHORIZATION", "Sikeres kartya ellenorzes.");
	define("SUCCESSFUL_WIRE", "Sikeres megrendeles. <br/>Az utalas megerkezese utan lesz teljesitve a megrendeles");
	define("SUCCESSFUL_CASH", "Sikeres megrendeles. <br/>Fizetes a kezbesiteskor");
	define("WAITING_FOR_IPN", "Megerositesre var!");
	define("CONFIRMED_IPN", "IPN megerositve, sikeres fizetes!");
	define("CONFIRMED_WIRE", "Beerkezett atutalas");
	define("UNSUCCESSFUL_TRANSACTION", "Sikertelen tranzakcio.");
	define("UNSUCCESSFUL_NOTICE", "Kerjuk, ellenorizze a tranzakcio soran megadott adatok helyesseget.<br>Amennyiben minden adatot helyesen adott meg, a visszautasitas okanak kivizsgalasa kapcsan kerjuk, sziveskedjen kapcsolatba lepni kartyakibocsato bankjaval.");
	define("END_OF_TRANSACTION", "Vege a tranzakcionak.");
	define("BACKREF_DATE", "Datum");
	define("DATE", "Datum");
	define("ORDER_ID", "Megrendeles azonosito");
	define("PAYREFNO", "PayU referenciaszam");
	define("STATUS", "Statusz");
	define("PAYMENT_TEST", "Teszt fizetes");
	define("DO_MORE_TESTS", "Vegezzen tovabbi teszteket!");
	define("DO_SUCCESSFUL_PAYMENT", "Teszteljen sikeres fizetest!");
	define("DO_UNSUCCESSFUL_PAYMENT", "Teszteljen sikertelen fizetest!");
	define("DO_CANCEL_PAYMENT", "Teszteljen megszakitott fizetest (\"Vissza\" gomb a fizetooldalon)!");
	define("ABORTED_TRANSACTION", "Megszakitott tranzakcio");
	define("TIMEOUT_TRANSACTION", "Idotullepeses tranzakcio	");
	define("TIMEOUT_PAGE_TITLE", "Idotullepes, vagy megszakitas");
	define("TIMEOUT_NOTICE", "On megszakitotta a fizetest, vagy lejart a tranzakcio maximalis ideje!");
}
else
{
	define("LANGUAGE", "EN");
	define("LIVEUPDATE_TEST_TRANSACTION", "LiveUpdate test transaction");
	define("BACKREF_REDIRECT_PAGE", "BackRef redirect page");
	define("TIMEOUT_PAGE", "Timeout page");
	define("SET_UP_MERCHANT", "Please define merchant id (MERCHANT) in sdk/config.php.");
	define("SET_UP_SECRET_KEY", "Please define secret key (SECRET_KEY) in sdk/config.php.");
	define("METHOD_CCVISAMC", "Credit card");
	define("METHOD_PAYU_MOBILE", "PayU mobile");
	define("METHOD_WIRE", "Wire transfer");
	define("METHOD_CASH", "Cash on delivery");
	define("METHOD_ON_PAYMENT_PAGE", "Select on payment page");
	define("PAYMENT_METHOD", "Payment method");
	define("SETTINGS", "Settings");
	define("PAYMENT_BUTTON", "Start PayU online payment");
	define("SELECT_ON_PAYMENT_PAGE", "select on PayU payment page");
	define("CARDS_FOR_TEST", "Cards for test");
	define("SUCCESFUL_PAYMENT", "Successful payment");
	define("UNSUCCESFUL_PAYMENT", "Unsuccessful payment");
	define("CARD_NUMBER", "Card number");
	define("EXPIRATION", "Card expiration date");
	define("ANY_THREE_NUMBERS", "any three numbers");	
	define("ANY_LATER", "any later");			
	define("SUCCESSFUL_CARD_AUTHORIZATION", "Successful card authorization.");
	define("SUCCESSFUL_WIRE", "Successful order.<br/>After successful wire transfer will be fulfilled your order.");
	define("SUCCESSFUL_CASH", "Successful order. <br/>Pay on delivery");
	define("WAITING_FOR_IPN", "Waiting for confirmation!");
	define("CONFIRMED_IPN", "IPN was confirmed, payment is successful!");
	define("CONFIRMED_WIRE", "Wire transfer has been received");
	define("UNSUCCESSFUL_TRANSACTION", "Unsuccessful transaction.");
	define("UNSUCCESSFUL_NOTICE", "Please check the data entered during the transaction.<br/>If you submitted every data correctly, please contact your account holder financial institute.");
	define("END_OF_TRANSACTION", "End of transaction.");
	define("BACKREF_DATE", "Date");
	define("DATE", "Date");
	define("ORDER_ID", "Order ID");
	define("PAYREFNO", "PayU reference number");
	define("STATUS", "Status");
	define("PAYMENT_TEST", "Payment test");
	define("DO_MORE_TESTS", "Do more tests!");
	define("DO_SUCCESSFUL_PAYMENT", "Make test with card for successful payments");
	define("DO_UNSUCCESSFUL_PAYMENT", "Make test with card for unsuccessful payments");
	define("DO_CANCEL_PAYMENT", "Make cancel payment (\"Cancel\" button on payment page)!");
	define("ABORTED_TRANSACTION", "Cancel on payment page");
	define("TIMEOUT_TRANSACTION", "Timeout");
	define("TIMEOUT_PAGE_TITLE", "Timeout or cancel");
	define("TIMEOUT_NOTICE", "On megszakitotta a fizetest, vagy lejart a tranzakcio maximalis ideje!");
}
$payrefno=isset($_GET['payrefno'])?" ".PAYREFNO.": ".$_GET['payrefno']:"";

$backref = new PayUHungaryBackRefPMB($config);
$backref->order_ref = $_REQUEST['order_ref'];
$backref->logger = $config['LOGGER'];
$backref->log_path = $config['LOG_PATH'];

$pre_msg='<h1><font color="green"><strong>';
$post_msg='</strong></font></h1>';
$pre_msg_err='<h1><font color="red"><strong>';
$post_msg_err='</strong></font></h1>';
$message="";
$message2="";

if($backref->checkResponse())
{
  $order_paid=1;
	$backStatus = $backref->backStatusArray;
	if ($backStatus['PAYMETHOD']=='Visa/MasterCard/Eurocard'||$backStatus['PAYMETHOD']=='PayU mobile') {
    $message=SUCCESSFUL_CARD_AUTHORIZATION.$payrefno;
		if ($backStatus['ORDER_STATUS']=='IN_PROGRESS') {
      $message.='<br />'.WAITING_FOR_IPN;
		} elseif ($backStatus['ORDER_STATUS']=='PAYMENT_AUTHORIZED' || $backStatus['ORDER_STATUS']=='COMPLETED') {
      $message.='<br />'.CONFIRMED_IPN;
		}
	}
	elseif ($backStatus['PAYMETHOD']=='Bank/Wire transfer') {
    $message=SUCCESSFUL_WIRE.$payrefno;
		if ($backStatus['ORDER_STATUS']=='PAYMENT_AUTHORIZED' || $backStatus['ORDER_STATUS']=='COMPLETED') {
      $message.='<br />'.CONFIRMED_WIRE;
		} 			
	}
	elseif ($backStatus['PAYMETHOD']=='Cash on delivery') {
      $message=SUCCESSFUL_CASH.$payrefno;
	}
}
else
{
  $message=UNSUCCESSFUL_TRANSACTION.$payrefno;
  $message.='<br />'.END_OF_TRANSACTION;
  $message.='<br />'.UNSUCCESSFUL_NOTICE;
}

if($order_paid==1)
{
  $message=$pre_msg.$message.$post_msg;
  $message2='alert(\''.str_replace("'","\\'",JText::_( 'PMB_MODULE_ORDER_SUCCESS' )).'\');';
}
else
{
  $message=$pre_msg_err.$message.$post_msg_err;
  $message2='alert(\''.str_replace("'","\\'",JText::_( 'PMB_MODULE_ORDER_CANCELED' )).'\');';
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
  <meta http-equiv="content-type" content="text/html; charset=windows-1250">
  <meta name="generator" content="PSPad editor, www.pspad.com">
  <title></title>
  </head>
  <body>
    <?php echo $message;?>
    <a href="http://<?php echo $_SERVER['HTTP_HOST']?>">Click Here</a> to renturn to our website.
    <script type="text/javascript">
    <?php echo $message2;?>
    //window.location='http://<?php echo $_SERVER['HTTP_HOST']?>';
    </script>
  </body>
</html>